package com.tzld.piaoquan.recommend.server.client;

import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.Message;
import com.google.protobuf.MessageOrBuilder;
import com.google.protobuf.util.JsonFormat;
import lombok.extern.slf4j.Slf4j;

/**
 * @author dyp
 */
@Slf4j
public class ProtobufUtils {
    public static String toJson(MessageOrBuilder message) {
        if (message == null) {
            return "";
        }
        try {
            return JsonFormat.printer().includingDefaultValueFields().print(message);
        } catch (InvalidProtocolBufferException e) {
            log.error("ProtobufUtils toJson error", e);
        }
        return "";
    }

    public static void fromJson(String json, Message.Builder builder) throws InvalidProtocolBufferException {
        JsonFormat.parser().merge(json, builder);
    }

//
//    public static void main(String[] args) throws InvalidProtocolBufferException {
//        RecommendResponse.Builder builder = RecommendResponse.newBuilder();
//        builder.setResult(Result.newBuilder().setCode(6).setMessage("success"));
//        String json = JsonFormat.printer().includingDefaultValueFields().print(builder);
//        System.out.println(json);
//
//        RecommendResponse.Builder builder2 = RecommendResponse.newBuilder();
//        JsonFormat.parser().merge(json, builder2);
//        System.out.println(JsonFormat.printer().print(builder2));
//    }
}
